#!/usr/bin/ruby
#
# tds2td.rb
# TDS`t@CtDiary`ɕϊ()
# Copyright (c) 2004 Yaya
#
# Usage: ruby tds2td.rb yyyymm tds_file [out_file]
#
# XV𓙂 http://yaya.sakura.ne.jp/diary/?category=tds2td QƁB

require "LineConvert"


#
# TDS->tDiary`ϊNX
class TDS2tDiaryByDay
	NKF_OPT = '-edx'							# [EUC][LF]

	#
	# td2t@Cwb_
	def top_header
		NKF.nkf(NKF_OPT, "TDIARY2.00.00\n")
	end

	#
	# ̓Lwb_
	def diary_header
	<<"END_OF_TEXT"
Date: #{@yyyy}#{@mm}#{@dd}
Title: 
Last-Modified: #{Time.local(@yyyy, @mm, @dd).to_i}
Visible: true
Format: tDiary
END_OF_TEXT
	end

	#
	# ̓Ltb^
	def diary_footer
		"\n.\n"
	end

	#
	# ϊ
	def convert(yyyy, mm, filename)
		@yyyy, @mm = yyyy, mm
		@dd = File.basename(filename, ".tdf")

		conv = LineConvertEx.new
		text = diary_header							# wb_

		# t@Csǂݍ
		f = open(filename)
		f.each{|line|
			puts "<= #{line}" if $DEBUG

			conv.convertCharRef!(line)
			conv.convertADic!(line)

			line_text = conv.convert.call(line)		# sϊ
			puts "=> #{line_text}" if $DEBUG
			text << line_text
		}
		f.close

		text << conv.leaveParagraph					# i
		text << diary_footer						# tb^
		NKF.nkf(NKF_OPT, text)						# R[hϊĕԋp
	end

	#
	# t@Co
	def write(out_file, text)
		out_file ||= "#{@yyyy}#{@mm}#{@dd}.td2"
		f = open(out_file, 'wb')
		f.print text
		f.close
	end
end

#
# ڌĂ΂ꂽꍇ̃C[`
if $0 == __FILE__

	# `FbN
	if ARGV.size < 2
		puts <<"END_OF_TEXT"
Usage: ruby tds2tdd.rb yyyymm tds_file [out_file]
END_OF_TEXT
		exit
	end

	yyyy, mm = ARGV.shift.match(/(\d\d\d\d)(\d\d)/)[1..2]	# N
	filename = ARGV.shift									# Lt@C
	out_file = ARGV.shift									# o̓t@C

	# TDStDiary`ϊ
	tds2td = TDS2tDiaryByDay.new
	text = tds2td.top_header
	text << tds2td.convert(yyyy, mm, filename)
	tds2td.write(out_file, text)

end

